--
-- WorkRPM
-- Increase motor RPM when using hydraulics tools (moving tools) and show RPM Hud.
-- @author:    	kenny456 (kenny456@seznam.cz) / Xentro (Marcus@Xentro.se) / Webby / [FSM]Chefkoch
-- @history:	v1.0 - 2017-11-06 - 
--				v1.1 - 2017-11-10 - fixed slowning down vehicle when running with implement turned on
--				v1.2 - 2017-12-02 - -added increase RPM when tipping
--									-added increase RPM when folding / unfolding implement / trailer
--									-added increase RPM to combines tipping and folding / unfolding pipe
--									-added increase RPM when moving movingTools of attached implements / trailers
--									-fixed slowning down machine when running with implement turned on or moving with movingTools
--
WorkRPM_register = {};
if SpecializationUtil.specializations["WorkRPM"] == nil then
	SpecializationUtil.registerSpecialization("WorkRPM", "WorkRPM", g_currentModDirectory.."WorkRPM.lua");
	WorkRPM_register.isLoaded = false; 
end;

function WorkRPM_register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		print("WorkRPM mod loaded")
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and (vs == SpecializationUtil.getSpecialization("drivable") or vs == SpecializationUtil.getSpecialization("attachable")) then
						local v_name_string = v.name 
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local _name = string.sub(v_name_string, 1, point_location-1);
							if rawget(SpecializationUtil.specializations, string.format("%s.WorkRPM", _name)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						if allowInsertion then	
							table.insert(v.specializations, SpecializationUtil.getSpecialization("WorkRPM"));
							allowInsertion = false;
						end;
					end;
				end;
			end;	
		end;
	end;
end;
function WorkRPM_register:deleteMap()
end;
function WorkRPM_register:keyEvent(unicode, sym, modifier, isDown)
end;
function WorkRPM_register:mouseEvent(posX, posY, isDown, isUp, button)
end;
function WorkRPM_register:update(dt)
end;
function WorkRPM_register:draw()
end;

addModEventListener(WorkRPM_register);
